searchData={"items":[{"type":"module","title":"prometheus_cowboy","doc":"Application module","ref":"prometheus_cowboy.html"},{"type":"function","title":"prometheus_cowboy.start/2","doc":"Start application","ref":"prometheus_cowboy.html#start/2"},{"type":"function","title":"prometheus_cowboy.stop/1","doc":"Stop application","ref":"prometheus_cowboy.html#stop/1"},{"type":"module","title":"prometheus_cowboy2_instrumenter","doc":"Collects Cowboy metrics using\n[metrics stream handler](https://github.com/ninenines/cowboy/blob/master/src/cowboy_metrics_h.erl)","ref":"prometheus_cowboy2_instrumenter.html"},{"type":"module","title":"Exported metrics - prometheus_cowboy2_instrumenter","doc":"- `cowboy_early_errors_total`:\n    Total number of Cowboy early errors, i.e. errors that occur before a request is received.\n    - Type: counter.\n    - Labels: default - `[]`, configured via `early_errors_labels`.\n- `cowboy_protocol_upgrades_total`:\n    Total number of protocol upgrades, i.e. when http connection upgraded to websocket connection.\n    - Type: counter.\n    - Labels: default - `[]`, configured via `protocol_upgrades_labels`.\n- `cowboy_requests_total`:\n    Total number of Cowboy requests.\n    - Type: counter.\n    - Labels: default - `[method, reason, status_class]`, configured via `request_labels`.\n- `cowboy_spawned_processes_total`:\n    Total number of spawned processes.\n    - Type: counter.\n    - Labels: default - `[method, reason, status_class]`, configured via `request_labels`.\n- `cowboy_errors_total`:\n    Total number of Cowboy request errors.\n    - Type: counter.\n    - Labels: default - `[method, reason, error]`, configured via `error_labels`.\n- `cowboy_request_duration_seconds`:\n    Cowboy request duration.\n    - Type: histogram.\n    - Labels: default - `[method, reason, status_class]`, configured via `request_labels`.\n    - Buckets: default - `[0.01, 0.1, 0.25, 0.5, 0.75, 1, 1.5, 2, 4]`,\n        configured via `duration_buckets`.\n- `cowboy_receive_body_duration_seconds`:\n    Request body receiving duration.\n    - Type: histogram.\n    - Labels: default - `[method, reason, status_class]`, configured via `request_labels`.\n    - Buckets: default - `[0.01, 0.1, 0.25, 0.5, 0.75, 1, 1.5, 2, 4]`,\n        configured via `duration_buckets`.","ref":"prometheus_cowboy2_instrumenter.html#module-exported-metrics"},{"type":"module","title":"Configuration - prometheus_cowboy2_instrumenter","doc":"Prometheus Cowboy2 instrumenter configured via `cowboy_instrumenter`\nkey of `prometheus` app environment.\n\nDefault configuration:\n\n```\n{prometheus, [\n    ...\n    {cowboy_instrumenter, [{duration_buckets, [0.01, 0.1, 0.25, 0.5,\n                                               0.75, 1, 1.5, 2, 4]},\n                           {early_error_labels,  []},\n                           {request_labels, [method, reason, status_class]},\n                           {error_labels, [method, reason, error]},\n                           {registry, default}]}\n    ...\n]}\n```","ref":"prometheus_cowboy2_instrumenter.html#module-configuration"},{"type":"module","title":"Labels - prometheus_cowboy2_instrumenter","doc":"Builtin:\n - host,\n - port,\n - method,\n - status,\n - status_class,\n - reason,\n - error.","ref":"prometheus_cowboy2_instrumenter.html#module-labels"},{"type":"module","title":"Custom labels - prometheus_cowboy2_instrumenter","doc":"Can be implemented via module exporting label_value/2 function.\nFirst argument will be label name, second is Metrics data from\n[metrics stream handler](https://github.com/ninenines/cowboy/blob/master/src/cowboy_metrics_h.erl)\nSet this module to `labels_module` configuration option.","ref":"prometheus_cowboy2_instrumenter.html#module-custom-labels"},{"type":"function","title":"prometheus_cowboy2_instrumenter.observe/1","doc":"[metrics stream handler](https://github.com/ninenines/cowboy/blob/master/src/cowboy_metrics_h.erl)\ncallback","ref":"prometheus_cowboy2_instrumenter.html#observe/1"},{"type":"function","title":"prometheus_cowboy2_instrumenter.setup/0","doc":"Sets all metrics up. Call this when the app starts.","ref":"prometheus_cowboy2_instrumenter.html#setup/0"},{"type":"extras","title":"Overview","doc":"# prometheus_cowboy #\n\n[![Hex.pm](https://img.shields.io/hexpm/v/prometheus_cowboy.svg?maxAge=2592000?style=plastic)](https://hex.pm/packages/prometheus_cowboy)\n[![Hex.pm](https://img.shields.io/hexpm/dt/prometheus_cowboy.svg?maxAge=2592000)](https://hex.pm/packages/prometheus_cowboy)\n[![Hex\nDocs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/prometheus_cowboy/)\n[![GitHub Actions](https://github.com/prometheus-erl/prometheus-cowboy/actions/workflows/ci.yml/badge.svg)](https://github.com/prometheus-erl/prometheus-cowboy/actions/workflows/ci.yml)\n[![Codecov](https://codecov.io/github/prometheus-erl/prometheus-cowboy/graph/badge.svg?token=G9HB5UKNIY)](https://codecov.io/github/prometheus-erl/prometheus-cowboy)","ref":"readme.html"},{"type":"extras","title":"Exporting metrics with handlers - Overview","doc":"Cowboy 1:\n\n```erlang\nRoutes = [\n          {'_', [\n                 {\"/metrics/[:registry]\", prometheus_cowboy1_handler, []},\n                 {\"/\", toppage_handler, []}\n                ]}\n         ]\n```\n\nCowboy 2:\n\n```erlang\nRoutes = [\n          {'_', [\n                 {\"/metrics/[:registry]\", prometheus_cowboy2_handler, []},\n                 {\"/\", toppage_handler, []}\n                ]}\n         ]\n```","ref":"readme.html#exporting-metrics-with-handlers"},{"type":"extras","title":"Exporting Cowboy2 metrics - Overview","doc":"```erlang\n    {ok, _} = cowboy:start_clear(http, [{port, 0}],\n                                 #{env => #{dispatch => Dispatch},\n                                   metrics_callback => fun prometheus_cowboy2_instrumenter:observe/1,\n                                   stream_handlers => [cowboy_metrics_h, cowboy_stream_h]})\n```","ref":"readme.html#exporting-cowboy2-metrics"},{"type":"extras","title":"License","doc":"The MIT License (MIT)\n\nCopyright (c) 2017, Ilya Khaprov  .\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}